CREATE OR REPLACE PROCEDURE "SAMPLE_PROCEDURE"(p_intage int4, p_intrate int4)
/************************************************************************/
/*    FUNCTION名    ：SAMPLE_PROCEDURE                                   */
/*    処理内容      ：従業員の賞与を更新する                            */
/*    引数          ：対象の年齢コード                                  */
/*                    倍率                                              */
/*    戻り値        ：更新したレコード件数                              */
/************************************************************************/
IS
/******************************** 宣言部 ********************************/
DECLARE
  -- カーソルの宣言
  curPer        refcursor;
  -- 変数の宣言
  intRtn        Integer;        -- 更新レコード数（返却用）
  recDt         record;         -- フェッチした内容を格納する為のレコード
/******************************** 処理部 ********************************/
BEGIN
  intRtn := 0;

  LOOP

    -- 現在のカーソルを指定レコードに格納(フェッチする)
    FETCH curPer INTO recDt;

    IF NOT FOUND THEN
      -- 最後まで読み込み終わればループ終了
      EXIT;
    END IF;

    UPDATE M_Person SET 
      Salary = 10000 * p_intRate
    WHERE
      PerCD = recDt.PerCD ;

    -- 更新したレコード件数をカウント
    intRtn := intRtn + SQL%ROWCOUNT;

  END LOOP;

    -- カーソルクローズ
  CLOSE curPer;

    -- コミット
  COMMIT;
/****************************** 例外処理部 ******************************/
EXCEPTION
  WHEN OTHERS THEN
    ROLLBACK; --ロールバックする
    SELECT 'OTHERS ERROR!!';
END
;
